﻿using System;
using System.Linq;
using System.Text;
using DevExpress.Xpo;
using DevExpress.ExpressApp;
using System.ComponentModel;
using DevExpress.ExpressApp.DC;
using DevExpress.Data.Filtering;
using DevExpress.Persistent.Base;
using System.Collections.Generic;
using DevExpress.ExpressApp.Model;
using DevExpress.Persistent.BaseImpl;
using DevExpress.Persistent.Validation;
using DevExpress.Persistent.Base.General;

namespace Solution5.Module.BusinessObjects
{
    [DefaultClassOptions]
    //[ImageName("BO_Contact")]
    //[DefaultProperty("DisplayMemberNameForLookupEditorsOfThisType")]
    //[DefaultListViewOptions(MasterDetailMode.ListViewOnly, false, NewItemRowPosition.None)]
    //[Persistent("DatabaseTableName")]
    // Specify more UI options using a declarative approach (https://documentation.devexpress.com/#eXpressAppFramework/CustomDocument112701).
    public class Category : BaseObject,ITreeNode
    { // Inherit from a different class to provide a custom primary key, concurrency and deletion behavior, etc. (https://documentation.devexpress.com/eXpressAppFramework/CustomDocument113146.aspx).
        public Category(Session session)
            : base(session)
        {
        }
        public override void AfterConstruction()
        {
            base.AfterConstruction();
            // Place your initialization code here (https://documentation.devexpress.com/eXpressAppFramework/CustomDocument112834.aspx).
        }

        private Category _ParentCategory;
        [Association("Category-Category")]
        public Category ParentCategory
        {
            get { return _ParentCategory; }
            set { SetPropertyValue("ParentCategory", ref _ParentCategory, value); }
        }

        private string _CategoryCode;
        public string CategoryCode
        {
            get { return _CategoryCode; }
            set { SetPropertyValue("CategoryCode", ref _CategoryCode, value); }
        }

        private string _CategoryName;
        public string CategoryName
        {
            get { return _CategoryName; }
            set { SetPropertyValue("CategoryName", ref _CategoryName, value); }
        }



        [DevExpress.Xpo.Aggregated, Association("Category-Category")]
        public XPCollection<Category> NestedCategorys
        {
            get { return GetCollection<Category>("NestedCategorys"); }
        }

        #region "ITreeNode Interface"
        string ITreeNode.Name
        {
            get
            {
                return CategoryName;
            }
        }

        ITreeNode ITreeNode.Parent
        {
            get
            {
                return ParentCategory;
            }
        }

        IBindingList ITreeNode.Children
        {
            get
            {
                return NestedCategorys;
            }
        }

        #endregion
    }
}